{--------------------------------------------------------------------}
{ Auteur  : Wim van der Vegt                                         }
{ Project : AVATAR Level 0, 0+ & 1 Protocol Interpreter              }
{--------------------------------------------------------------------}
{           All Command with ** as comment are NOT working (correct) }
{--------------------------------------------------------------------}
{ ddmmyy:hhmm opmerking                                              }
{ 160891:2000 Creatie                                                }
{ 210891:1500 Sound & Delays Tuned                                   }
{ 230891:2000 Demo Pictures are OK, Arrows NOT                       }
{ 240891:2000 Backspace, Exithandler & Tab Implemented               }
{             Clscr used, Auto Wrap Implemented,                     }
{             Cursor supression                                      }
{ 250891:1400 Optional Control Character Suppression                 }
{--------------------------------------------------------------------}
{ Nr.  To Do                                                         }
{  1.  Move's bij het scrollen van windows                           }
{  2.  XTALK Interface                                               }
{  3.  Answer on Driver Query (^V^Q)                                 }
{  4.  Test of Macro's                                               }
{  5.  Cursor uit bij tekenen, waarom staat cursor vaak op 0,0 ?     }
{  6.  MDA/Hercules Support                                          }
{  7.  Sideway Scrolling                                             }
{--------------------------------------------------------------------}

{ $DEFINE debug }     {DEFINE for ^V Command Line  }
{$DEFINE AVT0+ }      {DEFINE for AVT/0+ Support   }
{$DEFINE AVT1  }      {DEFINE for AVT/1 Support    }

PROGRAM Avatar(INPUT,OUTPUT);

USES
  Async,
  CRT,
  DOS;

TYPE
{----Window Definition, c=color, x&y Cursor position, t,l,b,r Window Location}
  w      = RECORD
             c,
             x,y,
             t,l,b,r : BYTE;
             zigzag,
             clock,
             reverse,
             static,
             vertical,
             wrap,
             insert      : BOOLEAN;
           END;

{----Screen Location (One Attribute & One Character}
  ca     = RECORD
             CASE BOOLEAN OF
               TRUE  : (w   : WORD);
               FALSE : (c,a : BYTE);
           END;

CONST
  serial : BOOLEAN = TRUE;

VAR
{----Screen Overlay}
  Screen    : ARRAY[1..25,1..80] OF ca ABSOLUTE $B800:0000;

{----256 Windows & Current Window Index}
  ws        : ARRAY[0..255] OF w;
  cw        : BYTE;

{----Used in Clockwise Mode}
  dx,dy     : INTEGER;

{----Vars for Main program}
  ch1,ch2  : BYTE;

{----Log  or Input File}
  fil       : FILE OF BYTE;

{----ALT-Q Pressed}
  rdy      : BOOLEAN;

CONST
{----Wake & Raw Mode}
  suppress  : BOOLEAN = TRUE;
  raw       : BOOLEAN = TRUE;
  wake      : BOOLEAN = TRUE;

  space     : BYTE = 32;

{----Communication Port}
  port      = 1;

{----No Parameters After a ^V opcode}
  rl        : ARRAY[$00..$3F] OF BYTE = (0,1,0,0,0,0,0,0,2 {^H},
                                         0,5,5,3,4,0,0     {^O},
                                         0,1,0,3,1,2,6     {^V},
                                         1,0,0,0,0,0,0     {FS},
                                         0,0,0             {SPACE},
                                         0,0,0,0,0,0,1,0,0,1,0,0,0,0,1,1 {0},
                                         1,0,0,0,0,0,0,0,0 {9},
                                         1,0,5,1,5,2       {?} );

{--------------------------------------------------------------------}

PROCEDURE Get(VAR ch : BYTE);

BEGIN
  IF serial
    THEN
      BEGIN
        ch:=Ord(Comreadch(port));
        WHILE Suppress AND (Chr(ch)=#00) DO ch:=Ord(Comreadch(port));
      END
    ELSE Read(fil,ch);

  IF (Chr(ch)=^P) AND NOT(raw)
    THEN
      BEGIN
        IF serial
          THEN ch:=Ord(Comreadchw(port))
          ELSE Read(fil,ch);
        ch:=ch AND $1F;
      END;
END; {of Get}

{--------------------------------------------------------------------}

PROCEDURE Play_tone(a,b,c : BYTE);

TYPE
  tone   = 'A'..'G';

CONST
  tones  : ARRAY [tone] OF REAL = (3520.00,
                                   3951.07,
                                   2093.00,
                                   2349.32,
                                   2637.02,
                                   2793.83,
                                   3135.96);
  sharp  : ARRAY [tone] OF REAL = (3729.31,
                                   4186.00,
                                   2217.46,
                                   2489.02,
                                   2393.83,
                                   2959.83,
                                   3322.44);

VAR
  i,
  octave  : INTEGER;

BEGIN
  octave:=1;
  FOR i:=2 DOWNTO b DO
    octave:=octave*2;
  IF (a<14)
    THEN
      BEGIN
        IF odd(a)
          THEN Sound(Round(sharp[Chr(Ord('A')+(a DIV 2))]/octave))
          ELSE Sound(Round(tones[Chr(Ord('A')+(a DIV 2))]/octave));
      END;
  Delay(100*c);
  Nosound;
END; {of play_tone}

{--------------------------------------------------------------------}

PROCEDURE Init_ws;

VAR
  i : BYTE;

BEGIN
  FOR i:=0 TO 255 DO
    WITH ws[i] DO
      BEGIN
        clock   :=FALSE;
        insert  :=FALSE;
        zigzag  :=FALSE;
        reverse :=FALSE;
        vertical:=FALSE;
        static  :=FALSE;
        wrap    :=TRUE;
        c       :=$07;
        t       :=1;
        l       :=1;
        b       :=25;
        r       :=80;
        x       :=1;
        y       :=1;
      END;

  dx:=1;
  dy:=1;

  raw :=TRUE;
  wake:=TRUE;

  cw:=0;
  WITH ws[cw] DO
    BEGIN
      Window(l,t,r,b);
      Textattr:=c;
    END;
END; {of Init_ws}

{--------------------------------------------------------------------}

FUNCTION Scr_Cursor_state : BOOLEAN;

VAR
  r : registers;

BEGIN
  r.ah:=$03;
  r.bh:=$00;
  Intr($10,r);

  Scr_cursor_state:=(r.cx<$2020)
END; {of SCR_cursor_state}

{--------------------------------------------------------------------}

PROCEDURE Scr_toggle_cursor;

VAR
  r : registers;

BEGIN
  r.ah:=$03;
  r.bh:=$00;
  Intr($10,r);

  r.ah:=$01;
  r.cx:=r.cx XOR $2020;
  Intr($10,r);
END; {of SCR_Toggle_cursor}

{--------------------------------------------------------------------}

PROCEDURE Scr_save_cursor;

BEGIN
  IF Scr_cursor_state
    THEN Scr_toggle_cursor;
END; {of SCR_Save_cursor}

{--------------------------------------------------------------------}

PROCEDURE Scr_restore_cursor;

BEGIN
  IF NOT Scr_cursor_state
    THEN Scr_toggle_cursor;
END; {of SCR_Restore_cursor}

{--------------------------------------------------------------------}

PROCEDURE Write_ch(ch : BYTE);

VAR
  xp,yp,
  i,j    : BYTE;

BEGIN
  xp:=WhereX;
  yp:=WhereY;

  WITH ws[cw] DO
    BEGIN
      IF NOT(Chr(ch) IN [#08,#09,#10,#13])
        THEN Screen[yp+t-1,xp+l-1].w:=WORD(c)*256+ch;

      IF clock AND (Chr(ch)<>#13)
        THEN
          BEGIN
            IF (xp=r-l+1) AND (yp=1)
              THEN BEGIN dy:=+1; dx:= 0; END;

            IF (yp=b-t+1) AND (xp=r-l+1)
              THEN BEGIN dy:= 0; dx:=-1; END;

            IF (xp=1) AND (yp=b-t+1)
              THEN BEGIN dy:=-1; dx:= 0; END;

            IF (yp=1) AND (xp=1)
              THEN BEGIN dy:= 0; dx:=+1; END;

             GotoXY(xp+dx,yp+dy);
          END
        ELSE
          BEGIN
            clock:=FALSE;
            CASE vertical OF
              TRUE : BEGIN
                       IF ws[cw].wrap OR (yp<b-t+1)
                         THEN
                           CASE Chr(ch) OF

                             #08 : IF (yp>1) THEN GotoXY(xp,yp-1);

                             #09 : IF ((((yp DIV 10)+1)*10)<b-t+1)
                                      THEN GotoXY(xp,((yp DIV 10)+1)*10);

                             #10 : IF (xp<r-l+1)
                                     THEN GotoXY(xp+1,yp)
                                     ELSE
                                       BEGIN
                                         FOR j:=t TO b DO
                                           Move(screen[j,l+1],screen[j,l],2*(r-l-1));
                                         FOR i:=t TO b DO screen[i,r].c:=space;
                                         GotoXY(r-l+1,1);
                                       END;

                             #13 : GotoXY(xp,1);

                             ELSE
                               IF (yp<b-t+1)
                                 THEN GotoXY(xp,yp+1)
                                 ELSE
                                   BEGIN
                                     Write_ch(Ord(#10));
                                     Write_ch(Ord(#13));
                                   END;
                           END;
                     END;

              FALSE: BEGIN
                       IF ws[cw].wrap OR (xp<r-l+1)
                         THEN
                           CASE Chr(ch) OF

                             #08 : IF (yp>1) THEN GotoXY(xp-1,yp);

                             #09 : IF ((((xp DIV 10)+1)*10)<r-l+1)
                                      THEN GotoXY(((xp DIV 10)+1)*10,yp);

                             #10 : IF (yp<b-t+1)
                                     THEN GotoXY(xp,yp+1)
                                     ELSE
                                       BEGIN
                                         FOR i:=t+1 TO b DO
                                           Move(screen[i,l],screen[i-1,l],2*(r-l));
                                         FOR j:=l TO r DO screen[b,j].c:=Ord(32);
                                         GotoXY(1,b-t+1);
                                       END;

                             #13 : GotoXY(1,yp);

                             ELSE
                               IF (xp<r-l+1)
                                 THEN GotoXY(xp+1,yp)
                                 ELSE
                                   BEGIN
                                     Write_ch(Ord(#10));
                                     Write_ch(Ord(#13));
                                   END;
                           END;
                     END;
            END;

          END;

      x:=WhereX;
      y:=WhereY;
    END;
END; {of Write_ch}

{--------------------------------------------------------------------}

PROCEDURE Debug(Opcode : BYTE);

BEGIN
  Window(1,1,80,25);

  GotoXY(1,25);
  IF (opcode<32)
    THEN Write('Command ^'+CHR(opcode+64))
    ELSE Write('Command  '+CHR(opcode));
  Write(' - ');

  CASE Chr(Opcode) OF

  {----AVATAR Level 0}
    ^A : Write('AVT/0  : Set Color');
    ^B : Write('AVT/0  : Blink on');
    ^C : Write('AVT/0  : Cursor Up');
    ^D : Write('AVT/0  : Cursor Down');
    ^E : Write('AVT/0  : Cursor Left');
    ^F : Write('AVT/0  : Cursor Right');
    ^G : Write('AVT/0  : Clear Eoln');
    ^H : Write('AVT/0  : Goto x,y');

  {----AVATAR Level 0+}
    ^I : Write('AVT/0+ : Insert ON');
    ^J : Write('AVT/0+ : Scroll Area Up');
    ^K : Write('AVT/0+ : Scroll Area Down');
    ^L : Write('AVT/0+ : Clear Area');
    ^M : Write('AVT/0+ : Fill Area');
    ^N : Write('AVT/0+ : Delete Char');
    ^Y : Write('AVT/0+ : Repeat Pattern');

  {----AVATAR Level 1}
    ^O : Write('AVT/1  : Clockwise on'#7);
    ^P : Write('AVT/1  : Dummy');
    ^Q : Write('AVT/1  : Query Driver'#7);
    ^R : Write('AVT/1  : Reset Driver');
    ^S : Write('AVT/1  : Sound Tone');
    ^T : Write('AVT/1  : Highlight At Cursor');
    ^U : Write('AVT/1  : Highlight a Window');
    ^V : Write('AVT/1  : Define a Window');
    ^W : Write('AVT/1  : Switch to a Window');
    ^] : Write('AVT/1  : Wake'#7);
    ^\ : Write('AVT/1  : Sleep'#7);
    ^^ : Write('AVT/1  : Vertical Mode');
    ^_ : Write('AVT/1  : Horizontal Mode');
    '!': Write('AVT/1  : Poke Character'#7);
    '"': Write('AVT/1  : Turn Wrap Off'#7);
    '#': Write('AVT/1  : ZigZag Mode on '#7);
    '$': Write('AVT/1  : No direction Switch at EOLN'#7);
    '%': Write('AVT/1  : Reverse LF Action'#7);
    '&': Write('AVT/1  : Normal LF Action'#7);
    #39: Write('AVT/1  : Set Cursor Type'#7);
    '(': Write('AVT/1  : No Reverse Printing'#7);
    ')': Write('AVT/1  : Reverse Printing'#7);
    '*': Write('AVT/1  : Pause');
    '+': Write('AVT/1  : Insert Blank Line'#7);
    ',': Write('AVT/1  : Insert Blank Column'#7);
    '-': Write('AVT/1  : Delete Line'#7);
    '.': Write('AVT/1  : Delete Column'#7);
    '/': Write('AVT/1  : Change Static Mode'#7);
    '0': Write('AVT/1  : Highlight EOLN'#7);
    '1': Write('AVT/1  : Highlight BOLN'#7);
    ':': Write('AVT/1  : Change Keyboard Mode'#7);
    '<': Write('AVT/1  : Scroll Area Left'#7);
    '=': Write('AVT/1  : Set Parser Mode');
    '>': Write('AVT/1  : Scroll Area Right'#7);
    '?': Write('AVT/1  : Peek Character'#7);
  ELSE   Write('AVT/?  : Unkown Command ['#7,opcode,']');
  END;

  Clreol;
  WITH ws[cw] DO
    BEGIN
      Window(l,t,r,b);
      GotoXY(x,y);
    END;
END; {of Debug}

{--------------------------------------------------------------------}

PROCEDURE Interpreter(ch : BYTE);

VAR
  i,j         : INTEGER;
  opcode,
  a,b,c,d,e,f,
  tc,
  x,y,
  rl,rc,r,rr  : BYTE;
  rep         : ARRAY[1..255] OF BYTE;

BEGIN
  WITH ws[cw] DO
    BEGIN
      Window(l,t,r,b);
      GotoXY(x,y);
      Textattr:=c;
    END;

  CASE CHR(ch) OF
    ^A,
    ^B,
    ^C,
    ^D,
    ^E,
    ^F,
    ^K,
    ^N,
    ^P,
    ^Q,
    ^R,
    ^S,
    ^T,
    ^U,
    ^W,
    ^X,
    ^Z : IF NOT(suppress) THEN Write_ch(ch);

    ^G : Write(#7);

    ^L : WITH ws[cw] DO
           BEGIN
             c:=$07;
             textattr:=c;
             Clrscr;
           END;

    ^Y : BEGIN
           Get(a); Get(b);
           FOR i:=1 TO b DO Write_ch(a);
         END;

    ^V : BEGIN
           Get(opcode);

           opcode:=opcode AND $3F;

{$IFDEF debug}
           Debug(opcode);
{$ENDIF}

           CASE CHR(opcode) OF

           {----AVATAR Level 0}
             ^A : Get(ws[cw].c);
             ^B : ws[cw].c:=ws[cw].c OR Blink;
             ^C : IF (WhereY> 1) THEN GotoXY(WhereX,WhereY-1);
             ^D : IF (WhereY<24) THEN GotoXY(WhereX,WhereY+1);
             ^E : IF (WhereX> 1) THEN GotoXY(WhereX-1,WhereY);
             ^F : IF (WhereX<80) THEN GotoXY(WhereX+1,WhereY);
             ^G : Clreol;
             ^H : BEGIN
                    Get(a); Get(b);
                    GotoXY(b,a);
                  END;

{$IFDEF avt0+}
           {----AVATAR Level 0+}
             ^I : ws[cw].insert:=TRUE;
             ^J : BEGIN
                    Get(a); Get(b); Get(c); Get(d); Get(e);
                    FOR i:=b+1 TO d DO
                      Move(screen[i,c],screen[i-1,c],2*(e-c));
                    FOR j:=c TO e DO screen[d,j].w:=WORD(a)*256+space;
                  END;
             ^K : BEGIN
                    Get(a); Get(b); Get(c); Get(d); Get(e);
                    FOR i:=d+1 DOWNTO b DO
                      Move(screen[i,c],screen[i+1,c],2*(e-c));
                    FOR j:=c TO e DO screen[b,j].w:=WORD(a)*256+space;
                  END;
             ^L : BEGIN
                    Get(a); Get(b); Get(c);
                    FOR i:=WhereX TO WhereX+c DO
                      FOR j:=WhereY TO WhereY+b DO
                        screen[j,i].w:=WORD(a)*256+space;
                    ws[cw].c:=a;
                  END;
             ^M : BEGIN
                    Get(a); Get(b); Get(c); Get(d);
                    textattr:=a;
                    FOR i:=WhereX TO WhereX+d DO
                      FOR j:=WhereY TO WhereY+c DO
                        screen[j,i].w:=WORD(textattr)*256+b;
                  END;
             ^N : MOVE(screen[WhereY,WhereX+1],
                       screen[WhereY,WhereX],
                       80-WhereX+1);
             ^Y : BEGIN
                    Get(a);
                    FOR i:=1 TO a DO
                      Get(rep[i]);
                    rl:=a;
                    Get(rc);
                    FOR r:=1 TO rc DO
                      FOR rr:=1 TO rl DO Interpreter(rep[rr]);
                  END;

{$ENDIF}

{$IFDEF avt1}
           {----AVATAR Level 1}
             ^O : ws[cw].clock:=TRUE;

             ^Q : Get(a);                                            {**}
             ^R : Init_ws;
             ^S : BEGIN
                    Get(a); Get(b); Get(c);
                    Play_tone(a,b,c);
                  END;
             ^T : BEGIN
                    Get(a);
                    IF (a>=$80)
                      THEN Screen[WhereY,WhereX].a:=
                           Screen[WhereY,WhereX].a OR $80;
                  END;
             ^U : BEGIN
                    Get(a);
                    Get(f);
                    WITH ws[a] DO
                      FOR i:=l TO r DO
                        FOR j:=t TO b DO
                          screen[j,i].a:=f;
                  END;
             ^V : BEGIN
                    Get(a);
                    IF a<>0
                      THEN
                        WITH ws[a] DO
                          BEGIN
                            Get(c);
                            Get(t);
                            Get(l);
                            Get(b);
                            Get(r);
                            Window(l,t,r,b);
                            Textattr:=c;
                            Clrscr;
                          END;
                  END;
             ^W : BEGIN
                    Get(cw);
                    WITH ws[cw] DO
                      BEGIN
                        Window(l,t,r,b);
                        Gotoxy(x,y);
                        textattr:=c;
                      END;
                  END;
             ^\ : wake:=FALSE;
             ^] : wake:=TRUE;
             ^^ : ws[cw].vertical:=TRUE;
             ^_ : ws[cw].vertical:=FALSE;
             '!': BEGIN
                    Get(a); Get(b); Get(c); Get(d);                  {**}
                  END;
             '"': ws[cw].wrap  :=FALSE;
             '#': ws[cw].zigzag:=TRUE;
             '$': ws[cw].wrap  :=TRUE;
             '%': ;                                                  {**}
             '&': ;                                                  {**}
             #39: Read(f,a);                                         {**}
             '(': ws[cw].reverse:=FALSE;
             ')': ws[cw].reverse:=TRUE;
             '*': BEGIN
                    Get(a);
                    IF (a<>0)
                      THEN Delay(a*100)
                      ELSE
                        BEGIN
                          i:=0;
                          WHILE NOT(KEYPRESSED) AND (i<36000) DO
                            BEGIN
                              DELAY(100);
                              Inc(i);
                            END;
                          IF (i<36000) AND (Readkey=#00)
                            THEN a:=Ord(Readkey);
                        END;
                  END;
             '+': ;                                                  {**}
             ',': ;                                                  {**}
             '-': ;                                                  {**}
             '.': ;                                                  {**}
             '/': BEGIN
                    Get(a);
                    CASE Chr(a) OF
                      '[' : ws[cw].static:=True;
                      ']' : ws[cw].static:=False;
                    END;
                  END;
             '0': BEGIN
                    Get(a);
                    FOR i:=WhereX TO 80 DO screen[WhereY,i].a:=a;
                  END;
             '1': BEGIN
                    Get(a);
                    FOR i:=WhereX DOWNTO 1 DO screen[WhereY,i].a:=a;
                  END;
             ':': Get(a);                                            {**}
             '<': BEGIN
                    Get(a);
                    get(b);
                    Get(c);
                    Get(d);
                    Get(e);                                          {**}
                  END;
             '=': BEGIN
                    Get(a);
                    CASE Chr(a) OF
                      'R' : raw:=True;
                      'C' : raw:=FALSE;
                    END;
                  END;
             '>': BEGIN
                    Get(a);
                    get(b);
                    Get(c);
                    Get(d);
                    Get(e);                                          {**}
                  END;
             '?': BEGIN
                    Get(a);
                    Get(b);                                          {**}
                  END;

{$ENDIF}

           END;
           ws[cw].x:=WhereX;
           ws[cw].y:=WhereY;
         END;
  ELSE Write_ch(ch);
  END;
END; {of Interpreter}

{--------------------------------------------------------------------}

VAR
  exitsave : POINTER;

{$F+}
PROCEDURE Avatar_exit;

BEGIN
  IF serial THEN Closecom(port);
  Scr_restore_cursor;
END; {of Avatar_exit}
{$F-}

{--------------------------------------------------------------------}

BEGIN
  Clrscr;

  exitsave:=Exitproc;
  exitproc:=@Avatar_exit;

  Init_ws;

  IF (paramcount=1)
    THEN
      BEGIN
        serial:=FALSE;
        Assign(fil,Paramstr(1)+'.avt');
        Reset(fil);
      END;

  rdy:=FALSE;

  IF serial AND Comexist(port) AND Opencom(port,1024,512)
    THEN
      BEGIN
        Comparams(port,2400,8,'N',1);
        REPEAT
          IF (combufferleft(port,'I')<>1024) AND NOT(Keypressed)
            THEN
              BEGIN
                Scr_save_cursor;
                REPEAT
                  Get(ch1);
                  Interpreter(ch1);
                UNTIL (combufferleft(port,'I')=1024) OR Keypressed;
                Scr_restore_cursor;
              END;

          IF Keypressed
            THEN
              BEGIN
                ch1:=Ord(Readkey);
                IF (ch1=Ord(#00))
                  THEN
                    BEGIN
                      ch2:=Ord(Readkey);
                      IF (ch2=Ord(#16))
                        THEN rdy:=TRUE
                        ELSE
                          BEGIN
                            Comwritech(port,Chr(ch1));
                            Comwritech(port,Chr(ch2));
                          END;
                    END
                  ELSE Comwritech(port,Chr(ch1));
              END;
        UNTIL rdy;
      END
    ELSE
      BEGIN
        Scr_save_cursor;
        rdy:=TRUE;
        WHILE NOT(eof(fil) OR Keypressed) DO
          BEGIN
            Get(ch1);
            Interpreter(ch1);
          END;
        Scr_restore_cursor;
      END;
END.

