/* REXX Script to convert EXPLORE.INI to WebExplorer_Url objects */

	call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
	call SysLoadFuncs

	found = 'false'
	call SysQueryClassList "list."
	do i = 1 to list.0
			if left(list.i, 15) = "WebExplorer_Url" Then do
				found = 'true'
				Say 'Found the WebExplorer_Url object class in the WPS Object registy'
			End
		if found = 'true' then
			Leave
	End
            
	if found = 'false' then do
		Say 'The WebExplorer_Url object class is not registered with the'
		Say 'Workplace Shell.  This program cannot continue'
		Say 'email jroepcke@compusmart.ab.ca for free support.'
		Exit
	end
	if SysOpenObject("<WEBXURLS>", "Icon", 1) = 0 then do
		Say 'Could  not find the <WEBXURLS> folder object.'
		Say 'Creating a new folder for URLs'
		destination = 'WP_DESKTOP'
		If SysCreateObject("WPFolder", "WebEx URLs", "<WP_DESKTOP>", "OBJECTID=<WEBXURLS>", "update") Then do
			Say 'Created/Updated the folder WebEx URLs on the desktop for the URL objects'
			rc = SysOpenObject("<WEBXURLS>", "Icon", 1)
		End
		Else Do
			Say 'Could not create the WebEx URLs folder.'
			Say 'email jroepcke@compusmart.ab.ca for free support.'
			Exit
		End
	End

	destination = '<WEBXURLS>'
	fspec = ''
	urlname = ''
	urlaref = ''

	fspec = SysSearchPath('ETC', 'Explore.Ini')

	if fspec <> '' Then
	Do
		rc = stream(fspec, 'c', 'open read')
		if rc <> 'READY:' then do
			Say 'Cannot open Explore.Ini.  Terminating...'
			Exit
		End

		DO WHILE lineread <> '[quicklist]'
			if stream(fspec, 's') = 'READY' Then
				lineread = LINEIN(fspec)
			else
				Leave
		END
		DO WHILE stream(fspec, 's') = 'READY'
			lineread = ''
			urlname = ''
			urlaref = ''
			tempstring = LINEIN(fspec)
			if tempstring = '' then
				Leave
			urlname = SUBSTR(tempstring, 12, length(tempstring) - 11)
			urlname = SPACE(urlname, 1, '_')
			urlaref = LINEIN(fspec)	
			if urlaref = '' then
				Leave
			If SysCreateObject("WebExplorer_Url", urlname, destination, "LOCATOR=" || urlaref, "replace") Then
				Say 'Successfully Created the object for ' || urlname
			Else
				Say 'Failure creating object for ' || urlname
		END
	stream(fspec, 'c' 'close')
	Say 'Finished the conversion!  Happy surfing!'
Exit	
